-module(test).

-export([test/0, test2/0,
  testn/1, testn_b/1]).


test() ->
  Timestamp_Now = erlang:system_time(second),
  L = lists:seq(1, 15),
  [myapp_events:add_task(integer_to_list(X), X, dynamic, X + 10) || X <- L, X rem 2 =:= 0],
  [myapp_events:add_task(integer_to_list(X), X, static, Timestamp_Now + X + 5) || X <- L, X rem 2 =:= 1],
  
  spawn(fun() ->
    timer:sleep(3000),
    
    myapp_events:add_task("12", 12, dynamic, 50),
    myapp_events:add_task("13", 13, static, Timestamp_Now + 80),
    
    myapp_events:delete_task("9", 9),
    myapp_events:delete_task("14", 14),
    
    ok
  end),
  
  ok.


test2() ->
  Timestamp_Now = erlang:system_time(second),
  L = lists:seq(1, 15),
  [myapp_events2:add_task(integer_to_list(X), X, dynamic, X + 10) || X <- L, X rem 2 =:= 0],
  [myapp_events2:add_task(integer_to_list(X), X, static, Timestamp_Now + X + 5) || X <- L, X rem 2 =:= 1],
  
  spawn(fun() ->
    timer:sleep(3000),
    
    myapp_events2:add_task("12", 12, dynamic, 50),
    myapp_events2:add_task("13", 13, static, Timestamp_Now + 80),
    
    myapp_events2:delete_task("9", 9),
    myapp_events2:delete_task("14", 14),
    
    ok
  end),
  
  ok.


testn(0) -> io:format("~p~n",["the end"]);
testn(T) -> % T -- умовно секунди - кількість циклів по 20_000 нових заявок та 20_000 видалень
  spawn(fun() ->
    timer:sleep(1000),
    testn(T - 1)
  end),
  
  spawn(fun() ->
    io:format("count before: ~p~n", [myapp_events2:check_ets_count()]),
    T1 = erlang:system_time(millisecond),
    testn_h(T rem 2 =:= 0),
    T2 = erlang:system_time(millisecond),
    io:format("count after: ~p~n", [myapp_events2:check_ets_count()]),
    io:format("~p milliseconds~n==========================================~n",[T2 - T1]),
    
    case T of
      1 ->
        % check count 5 sec after
        spawn(fun() ->
          timer:sleep(5000),
          io:format("result count: ~p~n", [myapp_events2:check_ets_count()])
        end),
        ok;
      _ -> ok
    end
    
  end),
  ok.

testn_h(true) ->
  %[myapp_events2:add_task(integer_to_list(X), X, dynamic, 5) || X <- lists:seq(1, 20_000)],
  %[myapp_events2:delete_task(integer_to_list(X), X) || X <- lists:seq(10_001, 30_000)],
  testn_h11(1),
  testn_h12(10_001),
  ok;
testn_h(_) ->
  Timestamp_Now = erlang:system_time(second),
  %[myapp_events2:add_task(integer_to_list(X) ++ ".", X, static, Timestamp_Now + 5) || X <- lists:seq(20_001, 40_000)],
  %[myapp_events2:delete_task(integer_to_list(X) ++ ".", X) || X <- lists:seq(30_001, 50_000)],
  testn_h13(20_001, Timestamp_Now),
  testn_h14(30_001),
  ok.

testn_h11(20_001) -> ok;
testn_h11(X) ->
  myapp_events2:add_task(integer_to_list(X), X, dynamic, 5),
  testn_h11(X + 1).
testn_h12(30_001) -> ok;
testn_h12(X) ->
  myapp_events2:delete_task(integer_to_list(X), X),
  testn_h12(X + 1).

testn_h13(40_001, _) -> ok;
testn_h13(X, Timestamp_Now) ->
  myapp_events2:add_task(integer_to_list(X) ++ ".", X, static, Timestamp_Now + 5),
  testn_h13(X + 1, Timestamp_Now).
testn_h14(50_001) -> ok;
testn_h14(X) ->
  myapp_events2:delete_task(integer_to_list(X) ++ ".", X),
  testn_h14(X + 1).


testn_b(0) -> io:format("~p~n",["the end"]);
testn_b(T) -> % T -- умовно секунди - кількість циклів по 20_000 нових заявок та 20_000 видалень
  spawn(fun() ->
    timer:sleep(1000),
    testn_b(T - 1)
  end),
  
  spawn(fun() ->
    io:format("count before: ~p~n", [myapp_events2:check_ets_count()]),
    T1 = erlang:system_time(millisecond),
    testn_h2(T rem 2 =:= 0),
    T2 = erlang:system_time(millisecond),
    io:format("count after: ~p~n", [myapp_events2:check_ets_count()]),
    io:format("~p milliseconds~n==========================================~n",[T2 - T1]),
    
    case T of
      1 ->
        % check count 5 sec after
        spawn(fun() ->
          timer:sleep(5000),
          io:format("result count: ~p~n", [myapp_events2:check_ets_count()])
        end),
        ok;
      _ -> ok
    end
    
  end),
  ok.

testn_h2(true) ->
  %[myapp_events2:add_task_b(integer_to_list(X), X, dynamic, 5) || X <- lists:seq(1, 20_000)],
  %[myapp_events2:delete_task_b(integer_to_list(X), X) || X <- lists:seq(10_001, 30_000)],
  testn_h21(1),
  testn_h22(10_001),
  ok;
testn_h2(_) ->
  Timestamp_Now = erlang:system_time(second),
  %[myapp_events2:add_task_b(integer_to_list(X) ++ ".", X, static, Timestamp_Now + 5) || X <- lists:seq(20_001, 40_000)],
  %[myapp_events2:delete_task_b(integer_to_list(X) ++ ".", X) || X <- lists:seq(30_001, 50_000)],
  testn_h23(20_001, Timestamp_Now),
  testn_h24(30_001),
  ok.

testn_h21(20_001) -> ok;
testn_h21(X) ->
  myapp_events2:add_task_b(integer_to_list(X), X, dynamic, 5),
  testn_h21(X + 1).
testn_h22(30_001) -> ok;
testn_h22(X) ->
  myapp_events2:delete_task_b(integer_to_list(X), X),
  testn_h22(X + 1).

testn_h23(40_001, _) -> ok;
testn_h23(X, Timestamp_Now) ->
  myapp_events2:add_task_b(integer_to_list(X) ++ ".", X, static, Timestamp_Now + 5),
  testn_h23(X + 1, Timestamp_Now).
testn_h24(50_001) -> ok;
testn_h24(X) ->
  myapp_events2:delete_task_b(integer_to_list(X) ++ ".", X),
  testn_h24(X + 1).



